<template>
    <div class="list-view">
        <div class="filters-container">
            <el-col :span="7">
                <span class="span-size">承办单位名称</span>
                <el-input
                    placeholder="输入承办单位名称"
                    v-model="search"
                    clearable
                    class="filter-item"
                    style="width: 220px"
                    @change="getData"
                ></el-input>
            </el-col>
            <el-col :span="7">
                <label class="span-size">承办单位地址</label>
                <el-select v-model="district" style="width: 220px" @change="getData" clearable>
                    <el-option
                        v-for="item in districts"
                        :key="item.id"
                        :value="item.name"
                        :label="item.name"
                    ></el-option>
                </el-select>
            </el-col>
            <el-col :span="10">
                <label class="span-size">注册时间</label>
                <el-date-picker
                    v-model="dateRange"
                    type="daterange"
                    value-format="yyyy-MM-dd HH:mm:ss"
                    start-placeholder="请选择开始时间"
                    end-placeholder="请选择结束时间"
                    range-separator="至"
                    :default-time="['00:00:00', '23:59:59']"
                    class="filter-item"
                    @change="getData"
                >
                </el-date-picker>
            </el-col>
            <!-- <el-col :span="8">
                    <span class="span-size">考级机构</span>
                    <el-select
                        v-model="agency"
                        placeholder="所属考级机构"
                        multiple
                        class="filter-item"
                        style="width: 220px"
                        @change="getData"
                    >
                        <el-option
                            v-for="(item, index) in examination"
                            :key="index"
                            :value="item.value"
                            :label="item.label"
                        ></el-option>
                    </el-select>
                </el-col> -->
            <!-- <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>-->
            <el-col :span="24">
                <el-button @click="addRow" type="primary" icon="el-icon-plus" class="filter-item">添加 </el-button>
                <el-button
                    @click="download"
                    type="primary"
                    icon="el-icon-download"
                    :loading="downloading"
                    class="filter-item"
                    :disabled="totalElements <= 0"
                    >导出EXCEL
                </el-button>
            </el-col>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
            :height="tableHeight"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <el-table-column prop="id" label="ID" width="80"> </el-table-column>
            <el-table-column prop="name" label="承办单位名称" show-overflow-tooltip> </el-table-column>
            <el-table-column prop="uscc" label="统一社会信用代码" show-overflow-tooltip></el-table-column>
            <el-table-column prop="district" label="所属区县"> </el-table-column>
            <el-table-column prop="businessLicense" label="营业执照" min-width="50">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px"
                        :src="row.businessLicense"
                        fit="cover"
                        :preview-src-list="[row.businessLicense]"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="owner" label="负责人"> </el-table-column>
            <el-table-column prop="privacyPolicy" label="法人姓名"> </el-table-column>
            <el-table-column prop="createdAt" label="注册时间" :formatter="datetimeFormatter"> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right" min-width="150">
                <template slot-scope="{ row }">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>查看</el-button>
                    <el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
import formatters from '@/mixins/formatters';

export default {
    name: 'OrganizationList',
    mixins: [pageableTable, formatters],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/organization/all',
            downloading: false,
            dateRange: '',
            district: '',
            districts: []
        };
    },
    created() {
        this.$http
            .post('/setting/byFlag', { flag: 2 })
            .then(res => {
                this.districts = res;
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    computed: {
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            // return {
            //     sort: 'createdAt,desc',
            //     search: this.search
            // };
            let data = {
                sort: 'createdAt,desc',
                query: {}
            };

            if (this.search) {
                data.search = this.search;
            }
            if (this.district) {
                data.query.district = this.district;
            }
            if (this.dateRange && this.dateRange.length > 0) {
                data.query.createdAt = this.dateRange[0] + ',' + this.dateRange[1];
            }
            return data;
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/organizationEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/organizationEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/organization/excel', {
                    responseType: 'blob',
                    params: { size: 10000 }
                })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        deleteRow(row) {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/organization/del/${row.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        this.$message.error(e.error);
                    }
                });
        }
    }
};
</script>
<style lang="less" scoped>
.span-size {
    font-size: 14px;
    color: #565b66;
    line-height: 15px;
    padding: 0 10px 0 10px;
}
</style>
